package com.syntevo.openapi.smartsvn.command.commit;

import java.util.*;

import com.syntevo.openapi.smartsvn.command.commit.*;

/**
 * @author syntevo GmbH
 */
public abstract class FilterCommitWorkflow implements ICommitWorkflow {

	// Fields =================================================================

	private final ICommitWorkflow baseWorkflow;

	// Setup ==================================================================

	public FilterCommitWorkflow(ICommitWorkflow baseWorkflow) {
		if (baseWorkflow == null) {
			throw new IllegalArgumentException("baseWorkflow expected");
		}

		this.baseWorkflow = baseWorkflow;
	}

	// Implemented ============================================================

	public ICommitConfigurationPhase getConfigurationPhase() {
		return baseWorkflow.getConfigurationPhase();
	}

	public List<ICommitPacketPhase> getPacketPhases() {
		return baseWorkflow.getPacketPhases();
	}

	public Set<CommitPacket> prepareForPacketPhases(Set<CommitPacket> packets) {
		return baseWorkflow.prepareForPacketPhases(packets);
	}

	public ICommitPreCommandPhase getPreCommandPhase() {
		return baseWorkflow.getPreCommandPhase();
	}

	public ICommitPostCommandPhase getPostCommandPhase() {
		return baseWorkflow.getPostCommandPhase();
	}
}