package com.syntevo.openapi.smartsvn.gui.menu;

import java.util.*;

/**
 * Contains all constants to reverence menu items in the SmartSVN project window.
 */
public final class ProjectActionIds {

	// Constants ==============================================================

	private static final Set<String> PRIVATE_ALL_IDS = new HashSet<String>();
	public static final String CHANGESET_DELETE = add("changeset-delete");
	public static final String CHANGESET_MOVE_DOWN = add("changeset-move-down");
	public static final String CHANGESET_MOVE_TO_OTHER = add("changeset-move-to-other");
	public static final String CHANGESET_MOVE_UP = add("changeset-move-up");
	public static final String CHANGESET_PROPERTIES = add("changeset-properties");
	public static final String EDIT_CUSTOMIZE = add("customize");
	public static final String EDIT_COPY_NAME = add("copy-name");
	public static final String EDIT_COPY_PATH = add("copy-path");
	public static final String EDIT_COPY_MESSAGE = add("edit-copy-message");
	public static final String EDIT_COPY_RELATIVE_PATH = add("copy-relative-path");
	public static final String EDIT_COPY_URL = add("copy-url");
	public static final String EDIT_FILTER = add("filter-files");
	public static final String OPEN = add("open");
	public static final String EDIT_PREFERENCES = add("preferences");
	public static final String EDIT_REVEAL_IN_FINDER = add("reveal-in-finder");
	public static final String EDIT_SELECT_COMMITTABLE = add("select-committable");
	public static final String EDIT_SELECT_DIRECTORY = add("select-directory");
	public static final String EDIT_SELECT_IN_FILE_TABLE = add("edit-select-in-file-table");
	public static final String EDIT_STOP = add("edit-stop");
	public static final String HELP_ABOUT = add("help-about");
	public static final String HELP_CHECK_FOR_UPDATE = add("help-check-for-update");
	public static final String HELP_CONTENT = add("help-content");
	public static final String HELP_DEBUG_LOG_ENABLE = add("debug-log-enable");
	public static final String HELP_OBFUSCATE_LOG_CACHE = add("help-obfuscate-log-cache");
	public static final String HELP_REGISTER = add("help-register");
	public static final String HELP_UNREGISTER = add("help-unregister");
	public static final String LOCKS_REFRESH = add("locks-refresh");
	public static final String LOCKS_LOCK = add("locks-lock");
	public static final String LOCKS_UNLOCK = add("locks-unlock");
	public static final String LOCKS_INFO = add("locks-info");
	public static final String LOCKS_CHANGE_NEEDS_LOCK = add("locks-change-needs-lock");
	public static final String MODIFY_ADD = add("add");
	public static final String MODIFY_CHECK_ADMIN_AREA = add("check-admin-area");
	public static final String MODIFY_COMMIT = add("commit");
	public static final String MODIFY_COPY = add("copy");
	public static final String MODIFY_COPY_WC_URL = add("copy-wc-url");
	public static final String MODIFY_COPY_URL_WC = add("copy-url-wc");
	public static final String MODIFY_COPY_URL_URL = add("copy-url-url");
	public static final String MODIFY_CLEANUP = add("cleanup");
	public static final String MODIFY_CREATE_DIRECTORY = add("create-directory");
	public static final String MODIFY_DELETE = add("delete-file");
	public static final String MODIFY_IGNORE = add("ignore-file");
	public static final String MODIFY_MARK_REPLACED = add("mark-replaced");
	public static final String MODIFY_MERGE = add("merge");
	public static final String MODIFY_MERGE_TWO_SOURCES = add("merge-two-sources");
	public static final String MODIFY_MERGE_REINTEGRATE = add("merge-reintegrate");
	public static final String MODIFY_MOVE = add("move");
	public static final String MODIFY_PATCH_APPLY = add("apply-patch");
	public static final String MODIFY_RELOCATE = add("relocate");
	public static final String MODIFY_REMOVE = add("remove");
	public static final String MODIFY_RENAME = add("rename");
	public static final String MODIFY_REPAIR = add("repair");
	public static final String MODIFY_RESOLVE = add("resolve");
	public static final String MODIFY_REVERT = add("revert");
	public static final String MODIFY_SMART_MOVE = add("smart-move");
	public static final String MODIFY_SWITCH = add("switch");
	public static final String MODIFY_UPDATE = add("update");
	public static final String MODIFY_UPDATE_MORE = add("update-more");
	public static final String MODIFY_UPDATE_EXCLUDE = add("update-exclude");
	public static final String PROJECT_CHECKOUT = add("checkout");
	public static final String PROJECT_CREATE_MODULE = add("create-module");
	public static final String PROJECT_CLOSE = add("close-project");
	public static final String PROJECT_DEFAULTS = add("project-defaults");
	public static final String PROJECT_EDIT_WORKING_COPY = add("edit-working-copy");
	public static final String PROJECT_EXIT = add("exit");
	public static final String PROJECT_MANAGER = add("project-manager");
	public static final String PROJECT_OPEN = add("open-project");
	public static final String PROJECT_OPEN_WORKING_COPY = add("create-project");
	public static final String PROJECT_REMOVE_WORKING_COPY = add("remove-working-copy");
	public static final String PROJECT_SETTINGS = add("project-settings");
	public static final String QUERY_ANNOTATE = add("annotate");
	public static final String QUERY_SHOW_CHANGES = add("compare");
	public static final String QUERY_COMPARE_2_FILES = add("compare-two-files");
	public static final String QUERY_COMPARE_TWO_URLS = add("compare-two-urls");
	public static final String QUERY_COMPARE_WITH_HEAD = add("compare-with-head");
	public static final String QUERY_COMPARE_WITH_PREVIOUS = add("compare-with-previous");
	public static final String QUERY_COMPARE_WITH_REVISION = add("compare-with-revision");
	public static final String QUERY_DIFF_LOCAL = add("diff-local");
	public static final String QUERY_DIFF_URLS = add("diff-urls");
	public static final String QUERY_LOG = add("log");
	public static final String QUERY_REVISION_GRAPH = add("revision-graph");
	public static final String QUERY_REMOTE_STATE_CLEAR = add("remote-state-clear");
	public static final String QUERY_REMOTE_STATE_REFRESH = add("remote-state-refresh");
	public static final String PROPERTIES_BUGTRAQ_EDIT = add("properties-bugtraq-edit");
	public static final String PROPERTIES_CHANGE_MIME_TYPE = add("properties-change-mime-type");
	public static final String PROPERTIES_EDIT = add("properties-edit");
	public static final String PROPERTIES_EOL_STYLE = add("properties-eol-style");
	public static final String PROPERTIES_EXECUTABLE_PROPERTY = add("properties-executable-property");
	public static final String PROPERTIES_EXTERNALS_EDIT = add("properties-externals-edit");
	public static final String PROPERTIES_IGNORE_EDIT = add("properties-ignore-edit");
	public static final String PROPERTIES_KEYWORD_SUBSTITUTION = add("properties-keyword-substitution");
	public static final String PROPERTIES_MERGEINFO_EDIT = add("properties-mergeinfo-edit");
	public static final String PROPERTIES_SET = add("properties-set");
	public static final String REPOSITORY_BROWSE = add("repository-open-entry");
	public static final String REPOSITORY_PROFILES = add("repository-profiles");
	public static final String REPOSITORY_CHANGE_MASTER_PASSWORD = add("repository-change-master-password");
	public static final String REPOSITORY_MANAGE_LOG_CACHES = add("rebuild-log-cache");
	public static final String REPOSITORY_SETUP = add("create-repository");
	public static final String TAG_ADD_TAG = add("tag-add-tag");
	public static final String TAG_ADD_BRANCH = add("tag-add-branch");
	public static final String TAG_BROWSER = add("tag-browser");
	public static final String TAG_LAYOUT_CONFIGURE = add("tag-layout-configure");
	public static final String TOOLS_CONFLICT_SOLVER = add("conflict-solver");
	public static final String TOOLS_EXPORT_BACKUP = add("export-backup");
	public static final String VIEW_ASSIGNED_TO_CHANGESET = add("view-assigned-to-changeset");
	public static final String VIEW_IGNORED = add("view-ignored");
	public static final String VIEW_RECURSIVE = add("view-recursive");
	public static final String VIEW_REFRESH = add("refresh");
	public static final String VIEW_REMOTE_CHANGED = add("view-remote-changed");
	public static final String VIEW_TABLE_COLUMNS = add("view-table-columns");
	public static final String VIEW_UNCHANGED = add("view-unchanged");
	public static final String VIEW_UNVERSIONED = add("view-unversioned");
	public static final String WINDOW_NEW_PROJECT_WINDOW = add("window-new");
	public static final String WINDOW_NEW_REPOSITORY_BROWSER = add("window-repository-browser");
	public static final String WINDOW_PERSPECTIVE_RESET = add("windows-reset-perspective");
	public static final String WINDOW_PERSPECTIVE_SET_MAIN = add("windows-perspective-set-main");
	public static final String WINDOW_PERSPECTIVE_SET_REVIEW = add("windows-perspective-set-review");
	public static final String WINDOW_SHOW_TRANSACTIONS_WINDOW = add("window-show-transaction-window");
	public static final String WINDOW_CHANGES_ACTIVATE = add("windows-changes-activate");
	public static final String WINDOW_CHANGES_IGNORE_CASE_CHANGES = add("window-changes-ignore-case-changes");
	public static final String WINDOW_CHANGES_IGNORE_WHITESPACES = add("window-changes-ignore-whitespaces");
	public static final String WINDOW_CHANGES_NEXT = add("window-changes-next");
	public static final String WINDOW_CHANGES_PREVIOUS = add("window-changes-previous");
	public static final String WINDOW_CHANGES_REFRESH = add("window-changes-refresh");
	public static final String WINDOW_CHANGES_SETTINGS = add("window-changes-settings");
	public static final String WINDOW_DIRECTORIES_ACTIVATE = add("windows-directories-activate");
	public static final String WINDOW_FILES_ACTIVATE = add("windows-files-activate");
	public static final String WINDOW_OUTPUT_ACTIVATE = add("windows-output-activate");
	public static final String WINDOW_OUTPUT_CLEAR = add("windows-output-clear");
	public static final String WINDOW_TRANSACTION_ACTIVATE = add("windows-transactions-activate");
	public static final String WINDOW_TRANSACTION_ANNOTATE = add("windows-transaction-annotate");
	public static final String WINDOW_TRANSACTION_CONFIGURE_WATCHED_URLS = add("windows-transaction-configure");
	public static final String WINDOW_TRANSACTION_COPY_PATH = add("windows-transaction-copy-path");
	public static final String WINDOW_TRANSACTION_LAYOUT_POPUP = add("windows-transaction-layout");
	public static final String WINDOW_TRANSACTION_MARK_ALL_AS_KNOWN = add("windows-transaction-mark-all-as-known");
	public static final String WINDOW_TRANSACTION_MARK_AS_KNOWN = add("windows-transaction-mark-as-known");
	public static final String WINDOW_TRANSACTION_MERGE = add("windows-transaction-merge");
	public static final String WINDOW_TRANSACTION_REFRESH = add("windows-transaction-refresh");
	public static final String WINDOW_TRANSACTION_ROLLBACK = add("windows-transaction-rollback");
	public static final String WINDOW_TRANSACTION_SET_COMMIT_MESSAGE = add("windows-transaction-set-commit-message");
	public static final String WINDOW_TRANSACTION_VIEW_ADDITIONAL_LOCATIONS = add("windows-transaction-show-additional-locations");
	public static final String WINDOW_TRANSACTION_VIEW_BRANCHES_TAGS = add("windows-transaction-show-tags");
	public static final String WINDOW_TRANSACTION_VIEW_SETTINGS = add("windows-transaction-settings");
	public static final Set<String> ALL_IDS = Collections.unmodifiableSet(PRIVATE_ALL_IDS);

	private static String add(String id) {
		if (!PRIVATE_ALL_IDS.add(id)) {
			throw new RuntimeException("id " + id + " already defined");
		}
		return id;
	}
}
